unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, Buttons;

type
  TForm1 = class(TForm)
    LbFont: TListBox;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Label1: TLabel;
    DrawGrid1: TDrawGrid;
    procedure LbFontDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormCreate(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure LbFontClick(Sender: TObject);
    procedure DrawGrid1Click(Sender: TObject);
  private
    procedure   RefreshList();
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    iScreenFont;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  ꗗZbg
procedure   TForm1.RefreshList();
var
    OldName: string;
    Index: integer;
begin
    //  ̑IʒuL^
    OldName := '';
    if (LbFont.ItemIndex <> -1) then OldName := LbFont.Items[LbFont.ItemIndex];
    //  XgXV
    LbFont.Items.Assign(ScreenFonts.Fonts);
    //  ł邾ʒuČ
    Index := LbFont.Items.IndexOf(OldName);
    if (Index <> -1) then LbFont.ItemIndex := Index; 
end;

//-----------------------------------------------------------------------------
//  RXgN^
procedure TForm1.FormCreate(Sender: TObject);
begin
    //  tHgɕύXĂ
    iScreenFont.RefreshProc := RefreshList;
    //  ͂Ƃčŏɕ\
    RefreshList();
end;

//-----------------------------------------------------------------------------
//  Xgڕ`
procedure TForm1.LbFontDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
    LB: TListBox;
    C: TCanvas;
    S: string;
    OffsetX, OffsetY: integer;
begin
    LB := TListBox(Control);
    C := LB.Canvas;
    S := LB.Items[Index];

    //  XgXVłȂ(...ʂ͋^)
    if (not ScreenFonts.Updating) then
    begin
        //  tHgύX
        C.Font.Name := S;
        //  ꂪȂListBox.Fontɐݒ肵CharSetɈĂ܂
        C.Font.Charset := ScreenFonts.LogFont[Index].lfCharSet;
    end;

    //  `ʒuvZ
    OffsetX := 2;
    OffsetY := ((Rect.Bottom - Rect.Top) - C.TextHeight(S)) div 2;

    //  `
    C.TextRect(Rect, OffsetX + Rect.Left, OffsetY + Rect.Top, S);
end;

//-----------------------------------------------------------------------------
//  Chr  Word 
function    WordToStr(const w: Word): string;
var
    HiB, LoB: Byte;
begin
    //  http://www.kanzaki.com/docs/jcode.html
    //  VtgJISł́A10i129`159A224`239i0x81`0x9FA0xE0`0xEFj̔
    //  ͂̃oCg2oCg[hJnÃoCg2oCg
    //  1oCgƂď܂B
    //  2oCg64`126A128`252i0x40`0x7EA0x80`0xFCj͈̔͂łȂ
    //  ΂Ȃ܂B

    HiB := Hi(w);
    LoB := Lo(w);

    //  2oCg
    if ((129 <= HiB) and (HiB <= 159)) or ((224 <= HiB) and (HiB <= 239)) then
    begin
        if ((64 <= LoB) and (LoB <= 126)) or ((128 <= LoB) and (LoB <= 252)) then
        begin
            Result := char(Hi(w)) + char(Lo(w));
        end
        else
        begin
            Result := '';
        end;
    end
    //  1oCg
    else if (HiB = 0) then
    begin
        Result := char(LoB);
    end
    //  ȊO
    else
    begin
        Result := '';
    end;
end;

//-----------------------------------------------------------------------------
//  ZʒuShiftJISR[h
function    CellToWord(const Col, Row: integer): Word;
var
    HiB, LoB: Byte;
begin
    //  1oCg
    HiB := (Row div 16);
    //  2oCg
    LoB := (Row mod 16) * 16 + Col;
    //  gݍ킹
    Result := MakeWord(LoB, HiB);
end;

//-----------------------------------------------------------------------------
//  Tv`
procedure TForm1.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
    Grid: TDrawGrid;
    C: TCanvas;
    OffsetX, OffsetY: integer;
    S: string;
begin
    Grid := TDrawGrid(Sender);
    C := Grid.Canvas;

    //  ̈ʒuɏׂ߂
    S := WordToStr(CellToWord(ACol, ARow));

    //  `ʒu
    OffsetX := ((Rect.Right - Rect.Left) - C.TextWidth(S)) div 2;
    OffsetY := ((Rect.Bottom - Rect.Top) - C.TextHeight(S)) div 2;

    //  `
    C.TextRect(Rect, Rect.Left + OffsetX, Rect.Top + OffsetY, S);
end;

//-----------------------------------------------------------------------------
//  R[h\
procedure TForm1.DrawGrid1Click(Sender: TObject);
var
    Grid: TDrawGrid;
    W: Word;
    HiB, LoB: Byte;
    S: string;
begin
    Grid := TDrawGrid(Sender);
    W := CellToWord(Grid.Col, Grid.Row);
    HiB := Hi(W);
    LoB := Lo(W);
    S := WordToStr(W);
    Label1.Caption := Format('$%s%s  %s', [IntToHex(HiB, 2), IntToHex(LoB, 2), S]);
end;

//-----------------------------------------------------------------------------
//  tHgύX
procedure TForm1.LbFontClick(Sender: TObject);
var
    i: integer;
begin
    i := LbFont.ItemIndex;
    if (-1 < i) and (i < ScreenFonts.Fonts.Count) then
    begin
        DrawGrid1.Font.Name := ScreenFonts.Fonts[i];
        DrawGrid1.Font.Charset := ScreenFonts.LogFont[i].lfCharSet;
        DrawGrid1.Canvas.Font.Assign(DrawGrid1.Font);
        DrawGrid1.Repaint();
    end;
end;

end.



                                       
