(*-----------------------------------------------------------------------------

    Screen.Fonts ̑ɂNX

    TLogFontA = packed record
        lfHeight    : Longint;      //  tHg̘_
        lfWidth     : Longint;      //  ̕ϕ
        lfEscapement: Longint;      //  eLXgs̊px
        lfOrientation: Longint;     //  x[XC̊px
        lfWeight    : Longint;      //  tHg̑
        lfItalic    : Byte;         //  C^bN̑̃tO
        lfUnderline : Byte;         //  t̃tO
        lfStrikeOut : Byte;         //  ł̃tO
        lfCharSet   : Byte;         //  Zbgʎq
        lfOutPrecision: Byte;       //  o͐x
        lfClipPrecision: Byte;      //  NbsOx
        lfQuality   : Byte;         //  o͕i
        lfPitchAndFamily: Byte;     //  sb`ƃtHgt@~̃tO
        lfFaceName  : array[0..LF_FACESIZE - 1] of AnsiChar;
                                    //  ^CvtFCX
    end;

    TEnumLogFont = packed record
        elfLogFont  : TLogFontA;    //  _tHg
        elfFullName : array[0..LF_FULLFACESIZE - 1] of AnsiChar;
                                    //  tHg̃tl[
        elfStyle    : array[0..LF_FACESIZE - 1] of AnsiChar;
                                    //  tHgX^C
    end;

    TNewTextMetric = record
        tmHeight    : Longint;      //  ̍
        tmAscent    : Longint;      //  ̃AZg
        tmDescent   : Longint;      //  ̃fBZg
        tmInternalLeading: Longint; //  fBO
        tmExternalLeading: Longint; //  OfBO
        tmAveCharWidth: Longint;    //  ̕ϕ
        tmMaxCharWidth: Longint;    //  ̍ő啝
        tmWeight    : Longint;      //  {[h
        tmOverhang  : Longint;      //  I[o[nO
        tmDigitizedAspectX: Longint;//  AXyNg
        tmDigitizedAspectY: Longint;//  AXyNg
        tmFirstChar : AnsiChar;     //  ŏ̕
        tmLastChar  : AnsiChar;     //  Ō̕
        tmDefaultChar: AnsiChar;    //  ftHg̕
        tmBreakChar : AnsiChar;     //  ؂蕶
        tmItalic    : Byte;         //  C^bNtO
        tmUnderlined: Byte;         //  tO                      
        tmStruckOut : Byte;         //  łtO
        tmPitchAndFamily: Byte;     //  sb`ƃt@~̃tO
        tmCharSet   : Byte;         //  Zbg
        ntmFlags    : DWORD;        //  rbg}XN
        ntmSizeEM   : UINT;         //  TPʂŕ\empTCY
        ntmCellHeight: UINT;        //  TPʂŕ\Z
        ntmAvgWidth : UINT;         //  TPʂŕ\̕ϕ
    end;

-----------------------------------------------------------------------------*)

unit iScreenFont;

interface

uses
    Windows, Messages, SysUtils, Classes;

type
    //  񋓂ꂽtHg̏ێNX
    TFontKeeper = class
    private
        FFontType   : integer;
        FEnumLogFont: TEnumLogFont;
        FTextMetrics: TNewTextMetric;
    public
        constructor Create(FontType: integer; LogFont: TEnumLogFont; TextMetrics: TNewTextMetric);
        property FontType: integer read FFontType;
        property EnumLogFont: TEnumLogFont read FEnumLogFont;
        property TextMetrics: TNewTextMetric read FTextMetrics;
    end;

    //  tHg̈ꗗێNX
    TScreenFonts = class
    private
        FUpdating : Boolean;
        FWndHandle: THandle;        //  EBhÉuӂv邽߂̃nh
        FFonts    : TStringList;    //  tHgێXg
        FAutoRefresh: Boolean;      //  tbV
    protected
        procedure   WndProc(var Msg: TMessage);
        procedure   Clear();
        function    GetFontKeeper(index: integer): TFontKeeper;
        function    GetEnumLogFont(index: integer): TEnumLogFont;
        function    GetTextMetric(index: integer): TNewTextMetric;
        function    GetLogFont(index: integer): TLogFont;
    public
        constructor Create(const AutoRefresh: Boolean);
        destructor  Destroy(); override;
        procedure   Refresh();
        property Fonts: TStringList read FFonts;
        property FontKeeper[index: integer]: TFontKeeper read GetFontKeeper;
        property EnumLogFont[index: integer]: TEnumLogFont read GetEnumLogFont;
        property TextMetrics[index: integer]: TNewTextMetric read GetTextMetric;
        property LogFont[index: integer]: TLogFont read GetLogFont;
        property Updating: Boolean read FUpdating;
        property AutoRefresh: Boolean read FAutoRefresh write FAutoRefresh;
    end;

type
    TRefreshProc = procedure() of object;    

var
    ScreenFonts: TScreenFonts = nil;
    RefreshProc: TRefreshProc = nil;

implementation

//-----------------------------------------------------------------------------
//  RXgN^
constructor TFontKeeper.Create(FontType: integer; LogFont: TEnumLogFont;
                                TextMetrics: TNewTextMetric);
begin
    FFontType := FontType;
    FEnumLogFont := LogFont;
    FTextMetrics := TextMetrics;
end;

//-----------------------------------------------------------------------------
//  EBhÊӂƂ̃EBhEvV[W
procedure   TScreenFonts.WndProc(var Msg: TMessage);
begin
    //  tHg̍\ς
    if Msg.Msg = WM_FONTCHANGE then
    begin
        //  tOătbV
        if FAutoRefresh then Refresh();
    end else
    //  łȂȂ
    begin
        //  ۓ
        Msg.Result := DefWindowProc(FWndHandle, Msg.Msg, Msg.wParam, Msg.lParam);
    end;
end;

//-----------------------------------------------------------------------------
//  RXgN^
constructor TScreenFonts.Create(const AutoRefresh: Boolean);
begin
    inherited Create;
    //  tO
    FUpdating := false;
    //  tbV
    FAutoRefresh := AutoRefresh;
    //  tHgێXg쐬
    FFonts := TStringList.Create;
    //  EBhÊӂ邽߂̃nh蓖
    FWndHandle := AllocateHWnd(WndProc);
    //  tHgXgXV
    Refresh();
end;

//-----------------------------------------------------------------------------
//  RXgN^
destructor  TScreenFonts.Destroy();
begin
    //  EBhÊӂ̂߂
    DeallocateHWnd(FWndHandle);
    //  tHgێXg
    FFonts.Free;
    inherited Destroy;
end;

//-----------------------------------------------------------------------------
//  NA
procedure   TScreenFonts.Clear();
begin
    while FFonts.Count > 0 do
    begin
        FFonts.Objects[0].Free;
        FFonts.Delete(0);
    end;
    FFonts.Clear();
end;

//------------------------------------------------------------------------
//  Delphi Win32 Graphics API t@X P618-
//  R[obN֐
function    FontEnumProc(LogFont: PEnumLogFont; TextMetrics: PNewTextMetric;
                FontType: integer; Strings: LPARAM): integer; stdcall;
var
    FaceName: string;
    FontKeeper: TFontKeeper;
begin
    //  tHgƃtHg^CvXgɒǉ
    FaceName := TEnumLogFont(LogFont^).elfLogFont.lfFaceName;
    if (Copy(FaceName, 1, 1) <> '@') then
    begin
        FontKeeper := TFontKeeper.Create(FontType, LogFont^, TextMetrics^);
        TStrings(Strings).AddObject(FaceName, FontKeeper);
    end;
    //  񋓌p
    Result := 1;
end;

//-----------------------------------------------------------------------------
//  tHgꗗXV
procedure   TScreenFonts.Refresh();
var
    DesktopDC: HDC;
begin
    FUpdating := true;
    Clear();
    DesktopDC := GetDC(GetDesktopWindow);
    EnumFontFamilies(DesktopDC, nil, @FontEnumProc, LPARAM(FFonts));
    ReleaseDC(GetDesktopWindow, DesktopDC);
    FFonts.Sort();
    if Assigned(RefreshProc) then RefreshProc();
    FUpdating := false;
end;

//-----------------------------------------------------------------------------
//  vpeBANZX - 1
function    TScreenFonts.GetFontKeeper(index: integer): TFontKeeper;
begin
    Result := TFontKeeper(FFonts.Objects[index]);
end;
//-----------------------------------------------------------------------------
//  vpeBANZX - 2
function    TScreenFonts.GetEnumLogFont(index: integer): TEnumLogFont;
begin
    Result := FontKeeper[index].EnumLogFont;
end;
//-----------------------------------------------------------------------------
//  vpeBANZX - 3
function    TScreenFonts.GetTextMetric(index: integer): TNewTextMetric;
begin
    Result := FontKeeper[index].TextMetrics;
end;
//-----------------------------------------------------------------------------
//  vpeBANZX - 4
function    TScreenFonts.GetLogFont(index: integer): TLogFont;
begin
    Result := FontKeeper[index].EnumLogFont.elfLogFont;
end;

//-----------------------------------------------------------------------------
//  ɍ
initialization
    ScreenFonts := TScreenFonts.Create(true);
//-----------------------------------------------------------------------------
//  ɂ߂
finalization
    ScreenFonts.Free;

end.

